<style>
	.searchResult {
		width: 100%;
		/* overflow-y: auto;
    overflow-x: hidden; */
		border-top: 0px;
	}

	.key_container span:hover {
		font-weight: bold;
	}

	b {
		white-space: pre;
	}

	.min-loading i::before {
		top: 0;
	}
</style>

<app-hint  [id]="'divSearchParent'" *ngIf="searchInput?.length" (click)="$event.stopPropagation()"></app-hint>
<div id="divSearchParent" (click)="onSuppressSuggestion()">
	<div class="inputpanel box-shadow-none" [ngClass]="(show_suggestions && search_suggestions.length>0) ?'sugOpen':''">
		<i class="las la-search fa-lg " style="transform: rotate(-90deg); font-size: 24px; color:#777;"></i>
		<div class="inputtag">
			<ng-container *ngFor="let bucket of recognizedBucket; let ind = index">
				<ng-container *ngIf="!bucket.hidden && !bucket.editable">
					<span bucket="true" [className]="bucket.class" (click)="makeEditbale(ind)">
						{{bucket.value}}
						<i *ngIf="bucket.type !== 'E'" (click)="removeBucket(ind)" class="fa fa-times-circle"></i>
					</span>
				</ng-container>
			</ng-container>

    </div>
    <!--(blur)="onBlur()" (keydown.enter)="onPressEnter()" (keydown)="onKeyDownHandler($event)" (click)="prevenDefault = true" (keyup.backspace)="onBackSpaceSearchHandler($event)" (keydown.space)="onSpaceSearchHandler($event)" [placeholder]="(recognizedBucket && recognizedBucket.length > 1)?'':'Ask for any data here'"  (focus)="onFocusSearchHandler()" -->
    <!-- [ngClass]="applyAuto?'auto_correct_anim':''" -->
    <div ngbDropdown #searchDrop="ngbDropdown" style="width: 100%;height: 39px;" class="dropdown">
    <div 
			appTokenize 
      id="search-input"
      [input_query]="searchInput"
    >
    </div>
    
    <input ngbDropdownToggle autocomplete="off" id="txtSearch" type="text"
      placeholder="Ask Jarvix any question about your business" spellcheck="false"
      [(ngModel)]="searchInput" />
      <div ngbDropdownMenu class="searchResultPanel" *ngIf="searchdropdown">
        <!-- <hr style="margin-top: -1px;margin-bottom: 0;width: 98.5%;border: 1px solid #E9E9E9"/> -->
        <div class="searchResult">
          <div class="d-flex" style="max-height: 554px;height:554px;">
            <div class="col-md-4 pl-0 pr-0" [ngClass]="search_suggestions.length>0?'col-md-4':'col-md-12'" [perfectScrollbar]>
              <div class="f-12 black fw-700 py-1 pl-3 bg-gray95 mb-0" style="border-left: 1px solid #eee;position: sticky; margin-left: 0.5px;
              top: 0;">From Your Data</div>
              <app-hint  [id]="'from-your-data'"></app-hint>
              <div *ngIf="filter_suggestions.masterDataFilter.length > 0" class="multi_list_container" class="key_container">
                  <ng-container *ngFor="let item of filter_suggestions.masterDataFilter;let i = index;">
                    <div class="mx-3 mt-0 pt-2 pb-2 f-14 blue-text fw-700 pl-1" *ngIf="item.type_index==0">{{item.type}}</div>
                    <ul class="p-0 mb-0">
                      <li [ngClass]="{'hover': (focused_filter_suggestion.position+focused_filter_suggestion.name) === (i+'masterDataFilter')}" class="pl-3"
                        (click)="selectSuggession(item.value,'MasterData'); selectSuggessionClicked=true;">
                        <i class="las fa-lg" [ngClass]="item.icon"></i> 
                        <span [innerHTML]="item.value" class="f-14"></span>
                      </li>
                    </ul>
                  </ng-container>
              </div>
              <div *ngIf="filter_suggestions.timeFilter.length > 0" class="key_container ">
                <ng-container>
                  <div class="mx-3 mt-0 pt-2 pb-2 f-14 blue-text fw-700 pl-1">Time Period</div>
                  
                  <ng-container *ngFor="let item of filter_suggestions.timeFilter;let i = index;">
                    <ul class="p-0 mb-0">
                    <li (click)="selectSuggession(item,'TimeFilter'); selectSuggessionClicked=true;" class="pl-3"
                    [ngClass]="{'hover': (focused_filter_suggestion.position+focused_filter_suggestion.name) === (i+'timeFilter')}"
                    ><i class="las la-clock fa-lg"></i>
                      <span [innerHTML]="item" class="f-14"></span>
                    </li>
                  </ul>
                  </ng-container>
                </ng-container>
              </div>
              <div *ngIf="filter_suggestions.activeDimList.length > 0 && !isHideActiveDimList" class="dim_list_container key_container">
                <div class="mx-3 mt-0 f-14 pt-2 blue-text fw-700 mb-1 pl-1">Dimension</div>
                <ng-container *ngFor="let item of filter_suggestions.activeDimList;let i = index;">
                  <ul class="p-0 mb-0">
                  <li (click)="selectSuggession(item,'DimOrMeasure'); selectSuggessionClicked=true;" class="pl-3"
                  [ngClass]="{'hover': (focused_filter_suggestion.position+focused_filter_suggestion.name) === (i+'activeDimList')}"
                  > <i class="las la-shapes fa-lg"></i> 
                    <span [innerHTML]="item" class="f-14"></span>
                  </li>
                </ul>
                </ng-container>
              </div>
              <div *ngIf="filter_suggestions.activeSuggestionList.length > 0 && !isHideActiveSuggestionList" class="dim_list_container key_container">
                <div class="mx-3 mt-0 pt-2 f-14 blue-text fw-700 mb-1 pl-1">Measure</div>
                <ng-container *ngFor="let item of filter_suggestions.activeSuggestionList;let i = index;">
                  <ul class="p-0 mb-0">
                  <li (click)="selectSuggession(item,'DimOrMeasure'); selectSuggessionClicked=true;" class="pl-3"
                  [ngClass]="{'hover': (focused_filter_suggestion.position+focused_filter_suggestion.name) === (i+'activeSuggestionList')}"
                  ><i class="las la-chart-line fa-lg"></i>
                    <span [innerHTML]="item" class="f-14"></span>
                  </li>
                </ul>
                </ng-container>
              </div>
              <!-- <div class="py-2"></div> -->
            </div>
            <div class="col-md-8 pr-0 pl-0" [perfectScrollbar] style="min-height:550px;border-left: 1px solid #eee;" *ngIf="search_suggestions.length>0">
              <!-- <div class="ml-3 py-2 search_tab_header" *ngIf="searchInput.length==0">Recent Searches</div> -->
              <div class="f-12 black fw-700 py-1 pl-3 mb-2 bg-gray95" style="position: sticky; 
              top: 0;">Search Suggestions
              </div>
              <app-hint  [id]="'search-suggestions'"></app-hint>
              <!-- <div class="ml-3 py-2 search_tab_heaer" *ngIf="relevant_history.length>0">People also searched for</div> -->
              <ng-container *ngFor="let item of search_suggestions;let i = index;">
                <li [ngClass]="{'hover': focused_suggestion == i}" (click)="select_suggestion(item);searchDrop.close();"
                  class="sug_list_items  py-2">
                  <i class="ml-3 fa-lg {{item.icon}}"></i>
                  <span [innerHTML]="item.value | highlightBold" class="mb-0 ml-2 f-14 "></span>
                </li>
              </ng-container>
              <div class="py-2"></div>
            </div>
          </div>
        </div>
        <div style="left:0.7vw;width: 48vw;position: absolute;top: 10px;z-index: -1;height: 540px;max-height: 540px;box-shadow: 0px 3px 10px 1px #7d7d7d5c;"></div>
      </div>
      
    </div>
    <!-- <button (click)="auto_correct_query()"
      *ngIf="tokenService.errorMatch.length" class="ml-2 mr-3 pt-1 auto-correct-query-button" ngbTooltip="Click to AutoCorrect your search phrase">
      AutoCorrect</button> -->
    <div (click)="resetSearch()"
      *ngIf="(searchInput && searchInput.length > 1)||(recognizedBucket && recognizedBucket.length > 1)" class="mr-3 pt-1"><i
        class="fa fa-times-thin fa-2x cursor" style="margin-top: -5px;z-index: 10;"></i></div>
    <div *ngIf="!isDevice">
      <span (click)="startSpeechRecognition()" style="cursor: pointer;" class="speechRec" *ngIf="!search_timeout.is_loading" placement="bottom" ngbTooltip="Click to use voice and ask questions in natural language">
        <img src="assets/imgs/mic-icon.svg">
      </span>
      <span (click)="startSpeechRecognition()" style="cursor: pointer;" class="speechRec min-loading" *ngIf="search_timeout.is_loading">
        <i class="las la-spinner fa-spin f-16" style="line-height: 1.5;"></i>
      </span>
      <app-hint [id]="'search-mic'" (click)="$event.stopPropagation()"></app-hint>
    </div>
  </div>
  <div style="left: 1.3vw; width: 49vw;position: absolute;top: 23px;z-index: -1;height: 26px;box-shadow: 0px 4px 10px rgba(0, 0, 0, 0.15);">
  </div>
</div>
<div id="divRunTimeStuff"></div>